/*********************************************************************************************************
 * Copyright (c) 2003-2009 Tersus Software Ltd. , All rights reserved.
 *
 * This program is made available under the terms of the GNU Lesser General Public License, version 2.1,
 * which is part of this distribution and is available at hhttp://www.gnu.org/licenses/lgpl-2.1.txt
 **********************************************************************************************************/
 tersus.newAction('Match', function()
{
	var pattern = this.getLeafChild('<Pattern>');
	var text = this.getLeafChild('<Text>');
	var ignoreCase = this.getLeafChild('<Ignore Case>');
	var allowPartial = this.getLeafChild('<Allow Partial Match>');
	
	var matchesExit = this.getExit('<Matches>');
	
	if (text == null)
		this.chargeEmptyExit('<Missing>');
	else
	{	
		if (allowPartial != true)
		{
			if (pattern.charAt(0) != '^')
				pattern = '^' + pattern;
		
			if (pattern.charAt(pattern.length -1) != '$')
				pattern = pattern + '$';
		}
				
		var modifier = ignoreCase?'i':'';
		var matches = text.match(new RegExp(pattern, modifier)); 
		
		if (matches != null)
		{
			this.chargeLeafExit('<Yes>',text);
			if (matchesExit)
			{
				var l = matches.length;
				for (var i=0;i<l;i++)
					this.chargeLeafExit(matchesExit, matches[i]);
			}
		}
    	else
    		this.chargeLeafExit('<No>',text);
    		
    }
});